Page MenuHomeVyOS Platform

VyOS-1.3: ping no longer supports specifying interface or source
Closed, ResolvedPublicBUG

Description

On VyOS 1.3 rolling,

The ping command fails when 'interface' arguemnt is given:

vyos@vyos-vm-2:~$ ping 10.2.1.1 interface 10.2.6.21
/bin/ping: invalid option -- 'I'
Try 'ping --help' or 'ping --usage' for more information.
vyos@vyos-vm-2:~$ ping 10.2.1.1 interface dum0
/bin/ping: invalid option -- 'I'
Try 'ping --help' or 'ping --usage' for more information.

The cause of this is that the "-I" switch is not included/supported in the version of ping shipped with vyos-1.3 (inetutils-ping) whereas 1.2.x was using iputils-ping. The ability to specify source interface / address is very important for most network administrators so this is a noticeable problem.

Details

Difficulty level
Normal (likely a few hours)
Version
1.3-rolling-202001020217
Why the issue appeared?
Issues in third-party code
Is it a breaking change?
Behavior change

Event Timeline

fahadysf created this task.Jan 16 2020, 1:05 PM
fahadysf updated the task description. (Show Details)Jan 16 2020, 1:10 PM
pasik added a subscriber: pasik.Jan 16 2020, 7:33 PM
Alfa80 added a subscriber: Alfa80.Jan 18 2020, 1:28 PM

VyOS on 'Buster' don't have flag "-I" for select specific interface for command ping.

root@vyos:/home/vyos#  dpkg-query -l | grep ping
ii  inetutils-ping                    2:1.9.4-7                                    amd64        ICMP echo tool
ii  iputils-arping                    3:20180629-2                                 amd64        Tool to send ICMP echo requests to an ARP address

Try to install iputils-ping, but it conflict with inetutils-ping

root@vyos:/home/sever# dpkg -i iputils-ping_20180629-2_amd64.deb 
Selecting previously unselected package iputils-ping.
dpkg: regarding iputils-ping_20180629-2_amd64.deb containing iputils-ping:
 inetutils-ping conflicts with ping
  iputils-ping provides ping and is to be installed.

dpkg: error processing archive iputils-ping_20180629-2_amd64.deb (--install):
 conflicting packages - not installing iputils-ping
Errors were encountered while processing:
 iputils-ping_20180629-2_amd64.deb
root@vyos:/home/sever#

I see one solution - with install pkg "fping", which have needed option.
It's installed without conflict's.

sever@vyos:~$ sudo fping -I eth0 -c 5 1.1.1.1
1.1.1.1 : [0], 84 bytes, 16.0 ms (16.0 avg, 0% loss)
1.1.1.1 : [1], 84 bytes, 16.5 ms (16.3 avg, 0% loss)
1.1.1.1 : [2], 84 bytes, 16.0 ms (16.2 avg, 0% loss)
1.1.1.1 : [3], 84 bytes, 16.0 ms (16.2 avg, 0% loss)
1.1.1.1 : [4], 84 bytes, 16.3 ms (16.2 avg, 0% loss)

1.1.1.1 : xmt/rcv/%loss = 5/5/0%, min/avg/max = 16.0/16.2/16.5

The maintainers can just replace inetutilsping with iputilsping as was the case in previous versions of VyOS. Just need this to be picked up by someone.

c-po claimed this task.Feb 4 2020, 3:59 PM
c-po changed Why the issue appeared? from Will be filled on close to Issues in third-party code.
c-po closed this task as Resolved.Feb 4 2020, 5:14 PM
c-po moved this task from Need Triage to Finished on the VyOS 1.3 Equuleus board.